#include <String.h>

#include "exc.h"
#include <errno.h>
#include <stddef.h>
#include <setjmp.h>
#include <math.h>

extern "C" {
};

//////////////////////
// CLASS Exception //
////////////////////
Exception:: Exception(char* error, int dberr): 
             error_d(error), dberr_num(dberr), err_num(::errno)           
{
}

Exception:: Exception(const Exception& e): error_d(e.error_d), dberr_num(e.dberr_num), err_num(e.err_num)
{
}


Exception:: ~Exception() {}

Exception:: operator const char*() { return (const char*)error_d; }

void Exception:: operator=(const Exception& e) {
  error_d = e.error_d;
  dberr_num = e.dberr_num;
  err_num = e.err_num;
}

void Exception:: operator()(char* error, int dberr) {
  error_d = error;
  dberr_num = dberr;
  err_num = ::errno;
}

Exception& Exception:: operator<< (const char* c) { 
  error_d += c; 
  return *this; 
}

Exception& Exception:: operator<< (unsigned long value) {

  char val[255];
  int next;

  int i=255;
  i--;
  val[i]=0;
  do {
    i--;
    if (i<0) {
      error_d += 
	"internal buffer too small for Exception:: operator<< (unsigned long value)";
      return *this;
    }
    next = floor(value/10);
    val[i]= '0' + (unsigned long) (value-next*10);
    value = next;
  } while (value);
  
  error_d += (val+i);

  return *this;
}

//////////////////////////////////////////////////////////////////
extern "C" {
  void Errorline();
  long abort_life();
};

extern jmp_buf env;

Exception dberror("");

void throw_error() {
  const char* err = (const char*)dberror;
  if (err[0] != '\0') Errorline("%s\n", err);
  dberror("");
  abort_life(TRUE);
  longjmp(env,FALSE); /* Back to main loop */ 
}
