#ifndef exceptions_hdr
#define exceptions_hdr

#include <String.h>

class String;
class Exception;

#define TRUE  1
#define FALSE 0

extern Exception dberror;
extern void throw_error();

#ifdef CHECK_UNEXPECTED
#define UNEXPECTED(cond, str) \
  if ( cond ) { \
    dberror << str; \
    throw_error(); \
  }
#else
#define UNEXPECTED(cond, str)
#endif 

#ifdef DEBUGPRINT
#define print_debug(V) V;
#else
#define print_debug(V)
#endif

//////////////////////
// CLASS Exception //
////////////////////
class Exception {
public:
  String error_d;
  int dberr_num;
  int err_num;
  
public:
  Exception(char* error, int dberr=0);
  Exception(const Exception&);
  ~Exception();

  void operator=(const Exception&);
  void operator()(char* error, int dberr=0);
  operator const char*();
  Exception& operator<< (const char* c);
  Exception& operator<< (unsigned long);
};

#endif
