#ifndef flist_hdr
#define flist_hdr

#include "dlist.h"

class FList;

#include <iostream.h>

class B_FL_Node:public B_DL_Node {
  friend class FList;
private:
  B_FL_Node* next2_d;
  B_FL_Node* prev2_d;

protected:
  B_FL_Node():next2_d(NULL), prev2_d(NULL) {}
  void insert_node(B_FL_Node* p, B_FL_Node* n);
  B_FL_Node* remove_node2(void);

  void output_data(ostream& os)const{
    B_DL_Node:: output_data(os);
    os << " FL_Node: "; OUTPUT(this, next2_d, prev2_d); }

public:
  ~B_FL_Node();

  B_FL_Node* next2( void ) const
    { return next2_d && next2_d->header_node() ? 
	(B_FL_Node*)NULL : next2_d; } 
  B_FL_Node* prev2( void ) const
    { return prev2_d && prev2_d->header_node() ? 
	(B_FL_Node*)NULL: prev2_d; } 
  virtual B_FL_Node* prepend2(B_FL_Node* n) 
    { if (n) n->insert_node(prev2_d, this); return n; }
  virtual B_FL_Node* append2(B_FL_Node* n)
    { if (n) n->insert_node(this, next2_d); return n;}
  virtual B_FL_Node* remove2(void) { return remove_node2(); }
  void remove(void) { 
    B_DL_Node:: remove(); remove_node2(); 
  }
  void check_data();
};


//////////////////
// CLASS FList //
////////////////
class FList {

  class HdrNode: public B_FL_Node {
  public:
    int header_node() const { return 1; }
  protected:
    void output_data(ostream&)const {}
  };

protected:
  HdrNode first_d;		// Pointer to first node
  HdrNode last_d;		// Pointer to last node

public:
  FList()
    {first_d.next2_d=&last_d; last_d.prev2_d=&first_d;}
  virtual ~FList();
  
  void prepend(B_FL_Node*); 
				// insert at the start of list
  void append(B_FL_Node*);	
				// append to end of the list
  void delete_a();	// delete at the start of list
  void delete_e();	// delete at the end of list
  B_FL_Node* remove_a();	// Remove start node from list, 
				// do NOT delete node.
  B_FL_Node* remove_e();	// Remove end node from list, 
				// do NOT delete node.
  B_FL_Node* first() const { return first_d.next2(); }
  B_FL_Node* last() const { return last_d.prev2(); }
  virtual void check_data();

  virtual int length();
  friend ostream& operator<<( ostream &, const FList& );
  
protected:
  virtual void output_data(ostream& os)const;

private:
  FList(const FList&);
  void operator=(const FList&);
};

#endif
