#include <iostream.h>

#include "hash_mat2.h"

////////////////////////
// CLASS B_HashMatrix2 //
//////////////////////
const int B_HashMatrix2:: num_of_primes = 86;

const int B_HashMatrix2:: hash_primes[] = 
{3, 7, 13, 19, 29, 41, 53, 67, 83, 97, 
 113, 137, 163, 191, 223, 263, 307, 349, 401, 461, 
 521, 653, 719, 773, 839, 911, 983, 1049, 1123, 1201,
 1279, 1367, 1459, 1549, 1657, 1759, 1861, 1973, 2081, 2179, 
 2281, 2383, 2503, 2617, 2729, 2843, 2963, 3089, 3203, 3323, 
 3449, 3571, 3697, 3833, 3967, 4099, 4241, 4391, 4549, 4703, 
 4861, 5011, 5171, 5333, 5483, 5669, 5839, 6029, 6197, 6361,
 6547, 6761, 6961, 7177, 7393, 7517, 7727, 7951, 8101, 8209, 
 16411, 32771, 65537, 131301, 262147, 524287};

B_HashMatrix2:: B_HashMatrix2(int x_capacity, int y_capacity):
                       x_size_d(capacity(x_capacity)), 
		       y_size_d(capacity(y_capacity))
{
  table_d = new DList*[x_size_d];
  for (int i=0; i < x_size_d; i++) {
    table_d[i] = new DList[y_size_d];
  }
}

B_HashMatrix2:: ~B_HashMatrix2() {
  for (int i=0; i < x_size_d; i++) {
    delete[] table_d[i];
  };
}

int B_HashMatrix2:: capacity(int cap) {

  int size=hash_primes[0];

  int l=0, u=num_of_primes-1, m;
  if ( cap > hash_primes[num_of_primes-1] ) {
    cerr << "*** In B_HashTable you need to increase hash_primes table to "
      << "atleast " << cap << "\n";
    
    size=hash_primes[num_of_primes-1];
  }
  else {
    while (1) {
      if (l==u) break;
      m = ( (l+u) >> 1 );
      if (cap > hash_primes[m]) {
	l=m+1;
      }
      else {
	u=m;
      }
    }
    size=hash_primes[l];
  };
  return size;
}


void B_HashMatrix2:: usage(ostream & os)const{
  os << "hash size [" << x_size_d << ", " << y_size_d << "]\n";
  os << "number of elements in the hash matrix: ";
  for (int i=0; i<x_size_d; i++) {
    for (int j=0; j<y_size_d; j++){
      int size = table_d[i][j].length();
      if (size != 0) {
	os << "[" << i << ", " << j << "]=" 
	   << table_d[i][j].length() << " ";
      }
    }
  }
}

void B_HashMatrix2:: output_data(ostream & os)const{
  os << "size: " << x_size_d << " * " << y_size_d << "\n";
  for (int i=0; i<x_size_d; i++) {
    for (int j=0; j<y_size_d; j++){
      os << "(" << i << "," << j << "): " 
	<< table_d[i][j] << "\n";
    }
  }
}

ostream& operator<<(ostream& os, const B_HashMatrix2& hm) {
  hm.output_data(os);
  return os;
}
