#include <iostream.h>
#include <string.h>

#include "odb.h"
#include "exc.h"

extern "C" {
#include <unistd.h>
#include <stdio.h>

  void write_str();
}

int byte_order_ok=1;

int hs_fd[2];

static int byte_order() {
  unsigned short v1 = 1;
  char* last_byte = (char*)&v1 + sizeof(unsigned short)-1;
  return *last_byte=='\001' ? 1:0;
}

extern void call_c_main(long, char**);

main(long argc, char **argv) {
    
  byte_order_ok = byte_order();

  int load_le=0;
  int fd[2];
  pid_t pid;

  fd[0]=fd[1]=-1;
  hs_fd[0]=hs_fd[1]=-1;


  String prog2;
   if (argc >= 2) {
     if (argv[1][0]=='1') load_le=1;
     argc--;
     argv++;
     prog2 = prog2 + (char*)getenv("LIFEHOME") + "/LineEditor/readline/rl";
   }

  if (load_le) {
    if ( (pipe(fd) < 0) || (pipe(hs_fd) < 0) ) {
      cerr << "Error: pipe error, could not run line editor" << "\n";
      call_c_main(argc, argv);
    }
    else {
      if ( (pid=fork()) < 0 ) {
	cerr << "Error: fork error, could not run line editor" << "\n";
	call_c_main(argc, argv);
      }
      else {
	if (pid>0) {		// parent process
	  
	  close(fd[1]);		// close write end
	  close(hs_fd[0]);
	  
	  if (fd[0] != STDIN_FILENO) {
	    if ( (dup2(fd[0],STDIN_FILENO)) != STDIN_FILENO) {
	      cerr << "Error: dup2 error to stdin in wild_life" << "\n";
	      exit (1);
	    }
	  };
	close(fd[0]);
	  
	call_c_main(argc, argv);	
	}
	else {			// child process
	  
	  char buf1[256];
	  char buf2[256];
	  sprintf(buf1, "%i", fd[1]);
	  sprintf(buf2, "%i", hs_fd[0]);
	  
	  close(fd[0]);		// close read end
	  close(hs_fd[1]);
	  
//	  char* prog = "/usr/local2/san/Life/LineEditor/readline/rl";

	  if ( execl((const char*)prog2, "rl", buf1, buf2, (char*)0) < 0) {
	    cerr << "Error: execl error for " << (const char*)prog2 << "\n";
	    exit (1);
	  }
	}
      }
    }
  }
  else {			// if (!load_le)
    call_c_main(argc, argv);	
  }
}

/* function needed to interact with line editor */
void write_str(int fd, const char* str) {
  static const int_len = sizeof(int);
  int len = strlen(str);
  size_t nleft, nwritten;
  const char* ptr;
 
  write(fd, (char*)&len, int_len);
  ptr = str;
  nleft = len;
 
  while (nleft > 0) {
    if ( (nwritten = write(fd, ptr, nleft)) <= 0 ) {
      cerr << "Error: writen error in wild_life" << "\n";
      exit (1);
    }
    nleft -= nwritten;
    ptr += nwritten;
  }
}

