#include <iostream.h>

#include "o_buffer.h"
#include "obj_page.h"
#include "extern-c++.h"
#include "obj_file.h"
#include "psi_obj.h"
#include "defs.h"

extern "C" {

void check_psi_term(ptr_psi_term*);
void check_bytedata(GENERIC*);

}

int append_object=1;

void ob_temp() {

}

//////////////////////
// ObjectPageNode //
////////////////////
#ifndef NO_OBJECT_PAGE
GENERIC ObjectPageNode:: alloc_ptr=NULL;
int ObjectPageNode:: n_of_nodes_d=0;

ObjectPageNode:: ~ObjectPageNode() {
//  cerr << "ObjectPageNode:: ~ObjectPageNode()\n";
}

ObjectNode* ObjectPageNode:: next_object(ObjectNode* obn) {
  return (ObjectNode*)obn->next2();
}

void ObjectPageNode:: flush_object_page() {
  
  UNEXPECTED( (!key().file()->file_writable()),
	      "unexpected error in ObjectPageNode:: flush_object_page()" );


  ObjectPage* page = NULL;
  ObjectNode* obn = (ObjectNode*)data_d.first();    
  
  while (obn) {
    UNEXPECTED( (!obn->key().dbpointer()),
		"unexpected error (null dbpointer) in ObjectPageNode:: flush_object_page()");
    ptr_psi_term t = obn->term();      
    deref_ptr(t);
    
    slot_num snum = obn->key().snum();
    if (t->dbpointer) {
      ObjectId& object_id = PSIID(t->dbpointer);	
      
      if (object_id.is_modified()) {
	print_debug((cerr <<  object_id
		     << " new features added " << "\n"));
	t->dbpointer=obn->key_d;
	obn->key().dbcoreffed_psi_term(t->dbpointer);
	if (!page) {
	  page = new ObjectPage(key_d);
	}
	PsiObject obj(t, snum, *page);
      }
      else {  // 1
	if (t->dbpointer != obn->key().dbpointer()) { 
	  // term t is stored as a pointer to
	  // another term.
	  if (!page) {
	    page = new ObjectPage(key_d);
	  }	      
	  ObjectId& object_id = PSIID(t->dbpointer);
	  obn->key().dbcoreffed_psi_term(t->dbpointer);
	  page->modify_object(snum, object_id.pnum(), 
			      object_id.snum(), OID_TYPE);
	  //	    cerr << key_d << "----" << obn->key()
	  //	      << " is made to coref "
	  //	      << object_id << "\n";
	  } 
      }
    }
    else { // t->dbpointer==NULL
      t->dbpointer=obn->key_d;
      obn->key().dbcoreffed_psi_term(t->dbpointer);
      if (!page) {
	page = new ObjectPage(key_d);
      }	 
      PsiObject obj(t, snum, *page);
    }
    obn=next_object(obn);    
  }
    
  delete page;
  
}

void ObjectPageNode:: check_data() {
  B_DL_Node:: check_data();
  //  cerr << "ObjectPageNode ";
  data_d.check_data();
  //  cerr << "ObjectPageNode over ";
}

void ObjectPageNode:: output_data(ostream& os)const {
  os << " ObjectPageNode: "; 
  B_DL_Node:: output_data(os);
  os << key();
  os << data();
}
#endif

///////////////////////
// CLASS ObjectNode //
/////////////////////
GENERIC ObjectNode:: alloc_ptr = NULL;
GENERIC ObjectNode:: Id:: alloc_ptr = NULL;
int ObjectNode:: n_of_nodes_d=0;

ObjectNode:: ~ObjectNode() {
//  cerr << "ObjectNode:: ~ObjectNode()\n";
}

void ObjectNode:: check_data() {
#ifndef NO_OBJECT_PAGE
  B_SL_Node:: check_data();
#else
  B_FL_Node:: check_data();
#endif
  check_psi_term(&term_d);
  check_bytedata(&key_d);
  key().check_data(); 
}

ptr_psi_term ObjectNode:: heap_psi_id_term(ptr_psi_term& in) {
  deref_ptr(in);
  if ((GENERIC)in < heap_pointer) {
    ptr_psi_term res = heap_psi_term(4);
    //    res->type=psi_id;
    res->type=in->type;
    push_psi_ptr_value(in, &(in->coref));
    in->coref=res;
    return res;
  }
  else {
//    in->type=psi_id;
#ifdef TS
    in->time_stamp=global_time_stamp;
#endif
    return in;
  }
}

int ObjectNode:: is_modified() {
  int modified=0;

  ptr_psi_term t = term();      
  deref_ptr(t);
  
  if (t->dbpointer != key().dbpointer()) {
    print_debug((cerr <<  key() << " is modified " << "\n"));
    modified=1;
  }
  else { // psi_term may have new features added to it.
    ObjectId& object_id = PSIID(t->dbpointer);
    if (object_id.is_modified()) {
      print_debug((cerr <<  key() << " new features added " << "\n"));
      modified=1;
    }
  }

  return modified;
}

void ObjectNode:: flush_object() {

  UNEXPECTED( (!key().dbpointer()),
	      "unexpected error (null dbpointer) in ObjectNode:: flush_object()");
  deref_ptr(term_d);
  slot_num snum = key().snum();
  ObjectPage* page=NULL;

  if (term_d->dbpointer) {
    ObjectId& object_id = PSIID(term_d->dbpointer);	
    
    if (object_id.is_modified()) {
      print_debug((cerr <<  object_id
		   << " new features added " << "\n"));
      term_d->dbpointer=key_d;
      key().dbcoreffed_psi_term(term_d->dbpointer);
      if (!page) {
	page = new ObjectPage(key());
      }
      PsiObject obj(term_d, snum, *page);
    }
    else {  // 1
      if (term_d->dbpointer != key().dbpointer()) { 
	// term t is stored as a pointer to
	// another term.
	if (!page) {
	  page = new ObjectPage(key());
	}	      
	ObjectId& object_id = PSIID(term_d->dbpointer);
	key().dbcoreffed_psi_term(term_d->dbpointer);
	page->modify_object(snum, object_id.pnum(), 
			    object_id.snum(), OID_TYPE);
	//	    cerr << key_d << "----" << key()
	//	      << " is made to coref "
	//	      << object_id << "\n";
      } 
    }
  }
  else { // term_d->dbpointer==NULL
    term_d->dbpointer=key_d;
    key().dbcoreffed_psi_term(term_d->dbpointer);
    if (!page) {
      page = new ObjectPage(key());
    }	 
    PsiObject obj(term_d, snum, *page);
  }
  delete page;
}

void ObjectNode:: output_data(ostream& os)const {
  os << " ObjectNode: ";
#ifndef NO_OBJECT_PAGE
  B_SL_Node:: output_data(os);
#else
  B_FL_Node:: output_data(os);
#endif
  ptr_psi_term  t = term_d;
  deref_ptr(t);
  os << key() << " => " << (char*)term_d->type->keyword->symbol;
  if (t->dbpointer != key().dbpointer()) {
    os <<  key() << " is modified ";
  }
  else { // psi_term may have new features added to it.
    if (key().is_modified()) {
      os <<  key() << " new features added ";
    }
  }
}

/////////////////////////
// CLASS ObjectBuffer //
///////////////////////
ObjectBuffer:: ObjectBuffer(int object_hash_size, 
			    int page_hash_size, 
			    int file_hash_size):
             obj_table(new ObjHashTable(file_hash_size, page_hash_size, 
					object_hash_size))
#ifndef NO_OBJECT_PAGE
	     ,page_objs_table(new PageObjsTable(file_hash_size, 
					       page_hash_size))
#endif
{
}

ptr_psi_term ObjectBuffer:: get_psi_term(const ObjectKey& o_key) {
  ObjectNode* obn = obj_table->fetch(o_key);
  if (obn) {
    mv2end(obn);
    return obn->term();
  }
  return (ptr_psi_term)NULL;
}

ptr_psi_term ObjectBuffer:: get_psi_term(const ObjectKey& o_key, 
					 GENERIC& dbpointer) {
  ObjectNode* obn = obj_table->fetch(o_key);
  if (obn) {
    mv2end(obn);
    dbpointer=obn->key_d;
    return obn->term();
  }
  dbpointer=NULL;
  return (ptr_psi_term)NULL;
}

// create a new heap psi_term and hash it on o_key.
ptr_psi_term ObjectBuffer:: insert_psi_term(const ObjectKey& o_key) {

#ifdef CHECK_UNEXPECTED
  ObjectNode* n = obj_table->fetch(o_key);
#endif   
  UNEXPECTED( (n), 
	      "unexpected error in ObjectBuffer:: insert_psi_term(const ObjectKey& o_key)-- object previously hashed");

  ObjectNode* obn = new ObjectNode(o_key);
  obj_table->insert(obn);

  if (append_object) append(obn); 
  else prepend(obn); // 1
#ifndef NO_OBJECT_PAGE
  append2object_page(obn);
#endif
  return obn->term();
}

// hash term on o_key.
ptr_psi_term ObjectBuffer:: insert_psi_term(const ObjectKey& o_key,
					    ptr_psi_term term) 
{
  deref_ptr(term);
  UNEXPECTED( (term->dbpointer),
	      "unexpected error in ObjectBuffer:: insert_psi_term(const ObjectKey& o_key, ptr_psi_term term)" );

#ifdef CHECK_UNEXPECTED
  ObjectNode* n = obj_table->fetch(o_key);
#endif   
  UNEXPECTED( (n), 
	      "unexpected error in ObjectBuffer:: insert_psi_term(const ObjectKey& o_key, ptr_psi_term term)-- object previously hashed");

  ObjectNode* obn = new ObjectNode(o_key,term);
  obj_table->insert(obn);

  if (append_object) append(obn); 
  else prepend(obn); // 1
#ifndef NO_OBJECT_PAGE
  append2object_page(obn);
#endif
  return obn->term();
}

// hash term on term->dbpointer.
ptr_psi_term ObjectBuffer:: insert_psi_term(ptr_psi_term term) 
{
  deref_ptr(term);
  UNEXPECTED( (!term->dbpointer),
	      "unexpected error in ObjectBuffer:: insert_psi_term(ptr_psi_term term)" );

#ifdef CHECK_UNEXPECTED
  ObjectId& object_id = PSIID(term->dbpointer);
  ObjectNode* n = obj_table->fetch(object_id);
#endif   
  UNEXPECTED( (n), 
	      "unexpected error in ObjectBuffer:: insert_psi_term(ptr_psi_term term) -- term previously hashed");

  ObjectNode* obn = new ObjectNode(term);
  obj_table->insert(obn);
  
  if (append_object) append(obn); 
  else prepend(obn); // 1
  ObjectId& oid = obn->key();  
#ifndef NO_OBJECT_PAGE
  append2object_page(obn);
#endif
  return obn->term();

}

int ObjectBuffer:: flush_object_buffer(int save_all) {
  int flushed=1;
  append_object=1;
  ObjectNode* obn = first_object();
  while(obn) {
    if (obn->key().file()->file_writable() && obn->is_modified()){
      //      cerr << obn->key() << " is modified\n";
      if ((heap_pointer-stack_pointer < FLUSH_THRESHOLD) && !save_all) {
	return 0;
      }
      else {
	flush_object(obn);
      }
    }
    else {
      //      cerr << obn->key() << " is ok\n";
    }
    obn = next_object(obn);
  }
  return flushed;
}

int ObjectBuffer:: is_flushed() {
  ObjectNode* obn = first_object();
  while(obn) {
    if (obn->key().file()->file_writable() && obn->is_modified())
      return 0;
    obn = next_object(obn);
  }
  return 1;
}

void ObjectBuffer:: check_data() {
#ifndef NO_OBJECT_PAGE
  SList:: check_data();
#else
  FList:: check_data();
#endif
  ObjectNode* obn = first_object();
  while(obn) {
    obn->check_data();
    //    cerr << "key: " << obn->key() << "\n";
    obn = next_object(obn);
  }
  obj_table->check_data();

#ifndef NO_OBJECT_PAGE
  //  cerr << "page_objs_table ";
  page_objs_table->check_data();
  //  cerr << "page_objs_table over ";
  init_object_page_iterator();
  ObjectPageNode* pon;
  while(pon=next_object_page()) {
    pon->check_data();
  }
#endif
}

long o_evict_count=0;
long object_evict_count=0;

int ObjectBuffer:: evict_objects(int min_num) {
  UNEXPECTED( (FList:: length() != length()),
	      "unexpected error in ObjectBuffer:: evict_objects()" );

  //  flush_object_buffer();

  int count= (min_num * length())/100;
  int count_val=count;
  if (count) {
    ObjectNode* obn = first_object();
    ObjectNode* next_obn=NULL;
    o_evict_count++;
    while(obn && count > 0) {
      next_obn=next_object(obn);
      if (obn->is_modified()) {
	if (!(obn->key().file()->file_writable())) {
	  count--;
	  delete obn;
	}
      }
      else {
	count --;
	obn->key().hashed_object(0);
	ptr_psi_term term = obn->term();
	term->type=psi_id;
	term->attr_list=NULL;
	term->value=NULL;
	delete obn;
      }
      obn = next_obn;
    }
    UNEXPECTED( (FList:: length() != length()),
		"unexpected error(2) in ObjectBuffer:: evict_objects()" );
    
#ifndef NO_OBJECT_PAGE
    init_object_page_iterator();
    ObjectPageNode* pon = next_object_page();
    ObjectPageNode* next_pon = NULL;
    while(pon) {
      next_pon = next_object_page();
      if(pon->data().first()) {}
      else {delete pon;}
      pon=next_pon;
    }
#endif
    int objects_evicted = count_val-count;
    object_evict_count += objects_evicted;
    return (objects_evicted);
  }
  return 0;
}

long evict_count=0;

int ObjectBuffer:: evict_objects(ObjFile* obj_file) {

  UNEXPECTED( (FList:: length() != length()),
	      "unexpected error in ObjectBuffer:: evict_objects(ObjFile* obj_file)" );

  //  flush_object_buffer();

  ObjectNode* obn = first_object();
  ObjectNode* next_obn=NULL;
  while(obn) {
    next_obn=next_object(obn);
    if (obn->key().file() == obj_file) {
      if (obn->is_modified()) {
	if (!(obn->key().file()->file_writable())) {
	  delete obn;
	}
	else {
	  Errorline("File \"%s\" is not flushed\n",
		    obn->key().file()->name());
	  return 0;
	}
      }
      else {
	obn->key().hashed_object(0);
	ptr_psi_term term = obn->term();
	term->type=psi_id;
	term->attr_list=NULL;
	term->value=NULL;
	delete obn;
      }
    }
    obn = next_obn;
  }
  UNEXPECTED( (FList:: length() != length()),
	      "unexpected error(2) in ObjectBuffer:: evict_objects(ObjFile* obj_file)" );

#ifndef NO_OBJECT_PAGE
  init_object_page_iterator();
  ObjectPageNode* pon = next_object_page();
  ObjectPageNode* next_pon = NULL;
  while(pon) {
    next_pon = next_object_page();
    if (pon->key().file()==obj_file) {
      if(pon->data().first()) {
	return 0;
      }
      else {
	delete pon;
      }
    }
    pon=next_pon;
  }
#endif

  return 1;

}


#ifndef NO_OBJECT_PAGE
void ObjectBuffer:: init_object_page_iterator() {
  page_objs_table->init_iterator();
}

ObjectPageNode* ObjectBuffer:: next_object_page() {
  return page_objs_table->next();
}

ObjectPageNode* ObjectBuffer:: get_object_page(const PageKey& p_key) {
       // get_object_page return a list of objects which
       // are in the same page.
  ObjectPageNode* p = (ObjectPageNode*)page_objs_table->fetch(p_key);
  return p;
}

ObjectPageNode* ObjectBuffer:: make_object_page(const PageKey& p_key) {
  ObjectPageNode* p = new ObjectPageNode(p_key);
  page_objs_table->insert(p);
  return p;
}
#endif

void ObjectBuffer:: output_data(ostream& os)const{
#ifndef NO_OBJECT_PAGE
  os << "*** OBJECTS: \n" << "_________\n";
  SList:: output_data(os);
  os << "\n*** PAGE_OBJECTS: \n" << "______________\n" << *page_objs_table;
#else
  os << "*** OBJECTS: \n" << "_________\n";
  FList:: output_data(os);
#endif
}

// int ObjectBuffer:: buf_length() {
//   int c=0;
//   ObjectNode* obn = first_object();
//   while(obn) {
//     c++;
//     obn = next_object(obn);
//   }
//   return c;
// }

void ObjectBuffer:: usage(ostream& os) {
  os << "number of objects in buffer is " << length() << "\n";
  obj_table->usage(os);
}
