#ifndef obj_file_hdr
#define obj_file_hdr

#include <iostream.h>

class DbFile;
class ObjFile;
struct FirstNewPage;
struct NewPage;

#include "odb.h"
#include "file.h"
#include "flist.h"

///////////////////
// CLASS DbFile //
/////////////////
class DbFile:public File {

protected:
  DbFileInfo* info_d;
  
public:
  ~DbFile();

protected:
  DbFile(const char* file_name, DbFileInfo* info, Nop);
  virtual off_t seek_page(const page_num& pnum) const=0;
  void output_data(ostream &)const;

};

struct FirstNewPage {};

class PageNode;
class PageObjectsNode;

////////////////////
// CLASS ObjFile //
//////////////////
class ObjFile:public DbFile {

public:
  enum { START, END, NEAR_OBJ };

protected:
  int file_writable_d;

private:
  DList dbpers_vars_d;
  // dbpers_vars_d contains varaiables not saved to disk.

public:
  ObjFile(const char* file_name);
  ~ObjFile(); 

  //  void flush_file();
  void flush_file_hdr(); // file_hdr flushed if file writable.

  const page_num& first_obj_page() const { 
    return ((ObjFileInfo*)info_d)->first_obj_page;
  }	
  const page_num& last_obj_page() const { 
    //    return ((ObjFileInfo*)info_d)->last_obj_page;
    return ((ObjFileInfo*)info_d)->num_of_obj_pages;
  }	
  const page_num& num_of_obj_pages() const {
    return ((ObjFileInfo*)info_d)->num_of_obj_pages;
  }
  page_num new_page_num(const page_num& prev_page_num);

  off_t seek_page(const page_num& pnum) const;

  void set_file_writable(int i) { file_writable_d=(i>0)?1:0; }
  int file_writable() { return file_writable_d; }

  void insert_dbpers_var(ptr_psi_term t);
  void check_dbpers_vars();
  int flush_dbpers_vars(int save_all);

protected:
  void output_page(ostream& , page_num);
  void output_data(ostream &);

public:
  void usage(ostream&);
};

class DBPersVarNode:public B_DL_Node {
public:
  ptr_psi_term t;

public:
  DBPersVarNode(ptr_psi_term term):t(term) {}

protected:
  void output_data(ostream&)const{};
};

#endif
