#include <sys/types.h>

#include "page.h"
#include "obj_file.h"
#include "exc.h"
#include "p_buffer.h"

/////////////////
// CLASS Page //
///////////////
Page:: Page():cache_d(NULL) 
{	// protected constructor
}

Page:: ~Page() {

}

int Page:: page_type()const{ 
  return PageInfo::type_d; 
}

void Page:: flush_page() { 
  UNEXPECTED( (!cache_d && !info_d),
	     "unexpected null values in Page:: write()" );
  if (cache_d->is_dirty()) {
    print_debug((cerr << "*** Flushing page " << page_id << "\n"))
    info_d->write_hdr(*cache_d);
    page_id->file()->seek_page(page_id->pnum());
    page_id->file()->write_file(*cache_d, cache_d->size());
    cache_d->dirty(0);
  }
}

void Page:: read_page() { 
  UNEXPECTED( (!cache_d && !info_d),
	     "unexpected null values in Page:: read()" )

  page_id->file()->seek_page(page_id->pnum());
  page_id->file()->read_file(*cache_d, cache_d->size());
  if (!(info_d->read_hdr(*cache_d))) {
    dberror << "corrupted file " << (const char*)page_id->file();
    throw_error();
  }
//  cache_d->has_data(1);
}

void Page:: make_new()const{
  off_t offset;
  
  // error if it is not a new page
//  offset = page_id->file()->seek_end();

//  UNEXPECTED( (page_id->bid < offset),
//	     "creating a new page when it already exists in Page::make_new()" )

  info_d->init(*cache_d);
}

void Page:: output_data(ostream& os)const{
  os << "Page Id: " << page_id->pnum() << "\n";
  os << *info_d;
}

ostream& operator<<(ostream& os, const Page& page) {
  page.output_data(os);
  return os;
}

