#ifndef slist_hdr
#define slist_hdr

#include "flist.h"

class SList;

#include <iostream.h>

class B_SL_Node:public B_FL_Node {
  friend class SList;
private:
  B_SL_Node* next3_d;
  B_SL_Node* prev3_d;

private:
  void insert_node(B_SL_Node* p, B_SL_Node* n);
  B_SL_Node* remove_node3(void);

protected:
  B_SL_Node():next3_d(NULL), prev3_d(NULL) {}

  void output_data(ostream& os)const{
    B_FL_Node:: output_data(os);
    os << " SL_Node: "; OUTPUT(this,next3_d,prev3_d); }

public:
  ~B_SL_Node();

  B_SL_Node* next3( void ) const
    { return next3_d && next3_d->header_node() ? 
	(B_SL_Node*)NULL : next3_d; } 
  B_SL_Node* prev3( void ) const
    { return prev3_d && prev3_d->header_node() ? 
	(B_SL_Node*)NULL: prev3_d; } 
  B_SL_Node* prepend3(B_SL_Node* n) 
    { if (n) n->insert_node(prev3_d, this); return n; }
  B_SL_Node* append3(B_SL_Node* n)
    { if (n) n->insert_node(this, next3_d); return n;}
  B_SL_Node* remove3(void) { return remove_node3(); }

  void remove(void) { // virtual fn.
    B_FL_Node:: remove(); remove_node3(); 
  }
  void check_data(); // virtual fn.

};


//////////////////
// CLASS SList //
////////////////
class SList {

  class HdrNode: public B_SL_Node {
  public:
    int header_node() const { return 1; }
  protected:
    void output_data(ostream&)const {}
  };

protected:
  HdrNode first_d;		// Pointer to first node
  HdrNode last_d;		// Pointer to last node

public:
  SList()
    {first_d.next3_d=&last_d; last_d.prev3_d=&first_d;}
  virtual ~SList();
  
  void prepend(B_SL_Node*); 
				// insert at the start of list
  void append(B_SL_Node*);	
				// append to end of the list
  void delete_a();	// delete at the start of list
  void delete_e();	// delete at the end of list
  B_SL_Node* remove_a();	// Remove start node from list, 
				// do NOT delete node.
  B_SL_Node* remove_e();	// Remove end node from list, 
				// do NOT delete node.
  B_SL_Node* first() const { return first_d.next3(); }
  B_SL_Node* last() const { return last_d.prev3(); }
  virtual void check_data();
  friend ostream& operator<<( ostream &, const SList& );
  
protected:
  virtual void output_data(ostream& os)const;

private:
  SList(const SList&);
  void operator=(const SList&);
};

#endif
