#ifndef rdb_channel_hdr
#define rdb_channel_hdr

#include <iostream.h>

#include "OdbSource/extern-c++.h"

class RdbChannel {

public:
  virtual ~RdbChannel() {}

  friend ostream& operator<<(ostream& os, const RdbChannel& ch);

public:
  virtual char* db_name()=0;
  virtual void database(char* d)=0;

  virtual void append_query(char* query, char* prefix, char* suffix)=0;
  virtual void sql_send()=0;
  virtual void sql_ok()=0;
  virtual long execute()=0;
  virtual long data()=0;
  virtual void cancel_query()=0;
  virtual void cancel_all()=0;

protected:
  virtual void output_data(ostream&)const=0;

//****** in file psi_sql.cpp ***********//
public:
  void create_table_query(char* relName, ptr_psi_term query);
  void alter_table_query(char* relName, ptr_psi_term query);
  void insert_query(char* relName, ptr_psi_term query);
  void update_query(char* relName, ptr_psi_term query);
  void select_query(char* relName, ptr_psi_term query,
		    ptr_psi_term notQuery);
  
private:
  void access_tree(ptr_node tree);
  void ctq(ptr_node n);
  void sq(ptr_node n);
  void iq(ptr_node n);
  void uq(ptr_node n);
  void wq(ptr_node n);
  void safe_str(char* des, char* src);
  void quote_send(char* str, char* str=NULL);
  void (RdbChannel::*sql_fn)(ptr_node);

};

#endif
