#include <syberror.h>
#include <sybfront.h>
#include <sybdb.h>

#include "Source/error.h"

extern int error_off;
static int Msgs = 0;

/******** SYBERRHANDLER
  
*/
static int syberr_handler(DBPROCESS* dbproc, int severity, 
			    int dberr, int oserr, char* dberrstr, 
			    char* oserrstr)
{
  if(!error_off) {
    if (Msgs) {
      Msgs=0;
    }
    else
      Errorline("(Sybase Error) %s\n", dberrstr);
    
    if (oserr != DBNOERR) 
      Errorline("(OS Error) %s Error: %d.\n", oserrstr);
  }
  return(INT_CANCEL);
}

/******** SYBMSGHANDLER
  
*/
int sybmsg_handler(DBPROCESS* dbproc, DBINT msgno, 
			  int msgstate, int severity, char* msgtext,
			  char* srvname, char* procname, 
			  DBUSMALLINT line)
{
  if(!error_off) {
    if (! severity==0 ) 
      Infoline("*** (Sybase Message) %s\n", msgtext);
/*    Msgs = 1; */
  }

  return(0);
}

void install_syberr() {
  dberrhandle(syberr_handler);
  dbmsghandle(sybmsg_handler);
}
